import xbmc,xbmcgui                                                                                                                                                                      
import subprocess,os
#import urllib2
import xbmcaddon
import json
import time
from urllib.request import urlopen

#Initialize ADDON
settings = xbmcaddon.Addon(id='micasaverde.addon')

#Initialize ADDON INFORMATION
ip                =  settings.getSetting( "vera_ip" )
dev               =  settings.getSetting( "vera_dev" )
devnight          =  settings.getSetting( "vera_night_id" )
debouncing_video  =  float(settings.getSetting( "debounce_video"))
debouncing_audio  =  float(settings.getSetting( "debounce_audio"))

__addonname__     = settings.getAddonInfo('name')
__icon__          = settings.getAddonInfo('icon')
plugin_start = "Plugin started"
plugin_error = "Please insert your vera information in the addon setting"
time1        = 5000
time2        = 3000

url           = ('http://%s:3480/data_request?id=status&output_format=json&DeviceNum=%s' % (ip, devnight))
winid_1       = float(settings.getSetting("winid_1"))
winid_2       = float(settings.getSetting("winid_2"))

#Initialize value for ref.
menu = 0
video = 0
audio = 0
stopmenu = 0

if (str(settings.getSetting("notification")) == "Yes"):
        if (ip == "0.0.0.0"):
                xbmc.executebuiltin('Notification(%s, %s, %d, %s)'%(__addonname__,plugin_error, time1, __icon__))
        else:
                xbmc.executebuiltin('Notification(%s, %s, %d, %s)'%(__addonname__,plugin_start, time2, __icon__))
       

                                                                                                                                                                                         
class MyPlayer(xbmc.Player):                                                                                                                                                             
                                                                                                                                                                                       
        def __init__ (self):                                                                                                                                                             
                xbmc.Player.__init__(self)
                if (str(settings.getSetting("xbmc_started")) == "Yes"):
                        urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=Xbmc_open' % (ip, dev))
                        if (str(settings.getSetting("debug_mod")) == "Yes"):
                                print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=Xbmc_open' % (ip, dev))
                else:
                        if (str(settings.getSetting("xbmc_started")) == "Night"):
                                data = json.load(urlopen(url))
                                night = (data[('Device_Num_%s' % devnight)]['states'][1]['value'])
                                if (str(night) == "0"):
                                        urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=Xbmc_open' % (ip, dev))
                                        if (str(settings.getSetting("debug_mod")) == "Yes"):
                                                print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=Xbmc_open' % (ip, dev))
                        
                                                                                                                                                                                        
        def onPlayBackStarted(self):
                xbmc.sleep(200) # it may take some time for xbmc to read tag info after playback started
                if xbmc.Player().isPlayingVideo():
                        currentvideo = xbmc.Player().getVideoInfoTag().getTitle()
                        currentvideo = currentvideo.replace(' ', '_')
                        if (str(settings.getSetting("video_started")) == "Yes"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Video_start' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Video_start' % (ip, dev))                               
                        if (str(settings.getSetting("video_started")) == "Night"):
                                data = json.load(urlopen(url))
                                night = (data[('Device_Num_%s' % devnight)]['states'][1]['value'])
                                if (str(night) == "0"):
                                        urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Video_start' % (ip, dev))
                                        if (str(settings.getSetting("debug_mod")) == "Yes"):
                                                print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Video_start' % (ip, dev))
                                       
                        if (str(settings.getSetting("video_title")) == "Yes"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=%s' % (ip, dev, currentvideo))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=%s' % (ip, dev, currentvideo))
                
                if xbmc.Player().isPlayingAudio() == True:
                        currentsong = xbmc.Player().getMusicInfoTag().getTitle()
                        currentsong = currentsong.replace(' ', '_')
                        if (str(settings.getSetting("audio_started")) == "Yes"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Audio_start' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Audio_start' % (ip, dev))
                        if (str(settings.getSetting("audio_started")) == "Night"):
                                data = json.load(urlopen(url))
                                night = (data[('Device_Num_%s' % devnight)]['states'][1]['value'])
                                if (str(night) == "0"):
                                        urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Audio_start' % (ip, dev))
                                        if (str(settings.getSetting("debug_mod")) == "Yes"):
                                                print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Audio_start' % (ip, dev))
                                
                                
                        if (str(settings.getSetting("audio_title")) == "Yes"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=%s' % (ip, dev, currentsong))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=%s' % (ip, dev, currentsong))
                                
        def onPlayBackEnded(self):                                                                                                                                                       
                if (VIDEO == 1):
                        time.sleep(debouncing_video)
                        if not xbmc.Player().isPlaying():
                                if (VIDEO == 1):                                                                                                                                                         
                                        if (str(settings.getSetting("video_ended")) == "Yes"):
                                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Video_end' % (ip, dev)) 
                                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Video_end' % (ip, dev))

                                        if (str(settings.getSetting("video_ended")) == "Night"):
                                                data = json.load(urlopen(url))
                                                night = (data[('Device_Num_%s' % devnight)]['states'][1]['value'])
                                                if (str(night) == "0"):
                                                        urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Video_end' % (ip, dev)) 
                                                        if (str(settings.getSetting("debug_mod")) == "Yes"):
                                                                print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Video_end' % (ip, dev))

                if (AUDIO == 1):
                        time.sleep(debouncing_audio)
                        if not xbmc.Player().isPlaying():
                                if (str(settings.getSetting("audio_ended")) == "Yes"):
                                        urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Audio_end' % (ip, dev))
                                        if (str(settings.getSetting("debug_mod")) == "Yes"):
                                                print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Audio_end' % (ip, dev))
                                if (str(settings.getSetting("audio_ended")) == "Night"):
                                        data = json.load(urlopen(url))
                                        night = (data[('Device_Num_%s' % devnight)]['states'][1]['value'])
                                        if (str(night) == "0"):
                                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Audio_end' % (ip, dev))
                                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Audio_end' % (ip, dev))
                                                                                                                                                                                                         
        def onPlayBackStopped(self):                                                                                                                                                     
                if (VIDEO == 1):                                                                                                                                                         
                        if (str(settings.getSetting("video_stopped")) == "Yes"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Video_stop' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Video_stop' % (ip, dev))
                        if (str(settings.getSetting("video_stopped")) == "Night"):
                                data = json.load(urlopen(url))
                                night = (data[('Device_Num_%s' % devnight)]['states'][1]['value'])
                                if (str(night) == "0"):
                                        urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Video_stop' % (ip, dev))
                                        if (str(settings.getSetting("debug_mod")) == "Yes"):
                                                print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Video_stop' % (ip, dev))
   
                if (AUDIO == 1):
                        if (str(settings.getSetting("audio_stopped")) == "Yes"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Audio_stop' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Audio_stop' % (ip, dev))
                        if (str(settings.getSetting("audio_stopped")) == "Night"):
                                data = json.load(urlopen(url))
                                night = (data[('Device_Num_%s' % devnight)]['states'][1]['value'])
                                if (str(night) == "0"):
                                        urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Audio_stop' % (ip, dev))
                                        if (str(settings.getSetting("debug_mod")) == "Yes"):
                                                print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Audio_stop' % (ip, dev))
                                                                                                                                                                                          
        def onPlayBackPaused(self):                                                                                                                                                      
                if xbmc.Player().isPlayingVideo():                                                                                                                                       
                        if (str(settings.getSetting("video_paused")) == "Yes"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Video_pause' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Video_pause' % (ip, dev))
                        if (str(settings.getSetting("video_paused")) == "Night"):
                                data = json.load(urlopen(url))
                                night = (data[('Device_Num_%s' % devnight)]['states'][1]['value'])
                                if (str(night) == "0"):
                                        urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Video_pause' % (ip, dev))
                                        if (str(settings.getSetting("debug_mod")) == "Yes"):
                                                print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Video_pause' % (ip, dev))
        
                if xbmc.Player().isPlayingAudio():
                        if (str(settings.getSetting("audio_paused")) == "Yes"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Audio_pause' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Audio_pause' % (ip, dev))
                        if (str(settings.getSetting("audio_paused")) == "Night"):
                                data = json.load(urlopen(url))
                                night = (data[('Device_Num_%s' % devnight)]['states'][1]['value'])
                                if (str(night) == "0"):
                                        urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Audio_pause' % (ip, dev))
                                        if (str(settings.getSetting("debug_mod")) == "Yes"):
                                                print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Audio_pause' % (ip, dev))
                                                
        def onPlayBackResumed(self):                                                                                                                                                     
                if xbmc.Player().isPlayingVideo():                                                                                                                                       
                        if (str(settings.getSetting("video_resumed")) == "Yes"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Video_resume' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Video_resume' % (ip, dev))

                        if (str(settings.getSetting("video_resumed")) == "Night"):
                                data = json.load(urlopen(url))
                                night = (data[('Device_Num_%s' % devnight)]['states'][1]['value'])
                                if (str(night) == "0"):
                                        urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Video_resume' % (ip, dev))
                                        if (str(settings.getSetting("debug_mod")) == "Yes"):
                                                print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Video_resume' % (ip, dev))

                if xbmc.Player().isPlayingAudio():
                        if (str(settings.getSetting("audio_resumed")) == "Yes"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Audio_resume' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Audio_resume' % (ip, dev))

                        if (str(settings.getSetting("audio_resumed")) == "Night"):
                                data = json.load(urlopen(url))
                                night = (data[('Device_Num_%s' % devnight)]['states'][1]['value'])
                                if (str(night) == "0"):
                                        urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Audio_resume' % (ip, dev))
                                        if (str(settings.getSetting("debug_mod")) == "Yes"):
                                                print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=Audio_resume' % (ip, dev))
                                           
player=MyPlayer()                                                                                                                                                                        
                                                                                                                                                                                         
VIDEO = 0

monitor = xbmc.Monitor()
while not monitor.abortRequested():
        if monitor.waitForAbort(1):
                break
#while(not xbmc.abortRequested):

        win   = (xbmcgui.getCurrentWindowId())

        if xbmc.Player().isPlaying():
                stopmenu = 1
                if xbmc.Player().isPlayingVideo():                                                                                                                                       
                        VIDEO = 1
                        AUDIO = 0
                else:                                                                                                                                                                    
                        VIDEO = 0
                        AUDIO = 1

        #Return to menu after playing
        if not xbmc.Player().isPlaying() and stopmenu != 0:
                menu = 0
                stopmenu = 0
                
                                                                                                                                                               
       
        if win == 10000 and menu != 10000:
                menu = 10000
                if (str(settings.getSetting("menu_home")) == "Night"):
                        data = json.load(urlopen(url))
                        night = (data[('Device_Num_%s' % devnight)]['states'][1]['value'])
                        if (str(night) == "0"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=home' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=home' % (ip, dev))
                                        
                else:
                        if (str(settings.getSetting("menu_home")) == "Yes"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=home' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=home' % (ip, dev))
                                        
        if win == 10001 and menu != 10001:
                menu = 10001
                if (str(settings.getSetting("menu_program")) == "Night"):
                        data = json.load(urlopen(url))
                        night = (data[('Device_Num_%s' % devnight)]['states'][1]['value'])
                        if (str(night) == "0"):
                               urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=program' % (ip, dev))
                               if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=program' % (ip, dev))
                else:
                        if (str(settings.getSetting("menu_program")) == "Yes"):
                               urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=program' % (ip, dev))
                               if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=program' % (ip, dev))
        
        
        if win == 10002 and menu != 10002:
                menu = 10002
                if (str(settings.getSetting("menu_picture")) == "Night"):
                        data = json.load(urlopen(url))
                        night = (data[('Device_Num_%s' % devnight)]['states'][1]['value'])
                        if (str(night) == "0"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=picture' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=picture' % (ip, dev))
                else:
                        if (str(settings.getSetting("menu_picture")) == "Yes"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=picture' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=picture' % (ip, dev))
                        
        
        
        if win == 10004 and menu != 10004:
                menu = 10004
                if (str(settings.getSetting("menu_setting")) == "Night"):
                        data = json.load(urlopen(url))
                        night = (data[('Device_Num_%s' % devnight)]['states'][1]['value'])
                        if (str(night) == "0"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=setting' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=setting' % (ip, dev))
                else:
                        if (str(settings.getSetting("menu_setting")) == "Yes"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=setting' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=setting' % (ip, dev))
                                

       #navigate video menu 
        if win == 10006 and menu != 10006:
                menu = 10006
                if (str(settings.getSetting("menu_video")) == "Night"):
                        data = json.load(urlopen(url))
                        night = (data[('Device_Num_%s' % devnight)]['states'][1]['value'])
                        if (str(night) == "0"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=video' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                       print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=video' % (ip, dev))
                else:
                        if (str(settings.getSetting("menu_video")) == "Yes"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=video' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                       print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=video' % (ip, dev))

                       
        if win == 10024 and menu != 10024:
                menu = 10024
                if (str(settings.getSetting("menu_video")) == "Night"):
                        data = json.load(urlopen(url))
                        night = (data[('Device_Num_%s' % devnight)]['states'][1]['value'])
                        if (str(night) == "0"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=video' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                       print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=video' % (ip, dev))
                else:
                        if (str(settings.getSetting("menu_video")) == "Yes"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=video' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                       print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=video' % (ip, dev))
                                

        if win == 10025 and menu != 10025:
                menu = 10025
                if (str(settings.getSetting("menu_video")) == "Night"):
                        data = json.load(urlopen(url))
                        night = (data[('Device_Num_%s' % devnight)]['states'][1]['value'])
                        if (str(night) == "0"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=video' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                       print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=video' % (ip, dev))
                else:
                        if (str(settings.getSetting("menu_video")) == "Yes"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=video' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                       print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=video' % (ip, dev))
                        

                       
        if win == 10028 and menu != 10028:
                menu = 10028
                if (str(settings.getSetting("menu_video")) == "Night"):
                        data = json.load(urlopen(url))
                        night = (data[('Device_Num_%s' % devnight)]['states'][1]['value'])
                        if (str(night) == "0"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=video' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=video' % (ip, dev))
                else:
                        if (str(settings.getSetting("menu_video")) == "Yes"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=video' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=video' % (ip, dev))
                        


        #navigate audio menu                 
        if win == 10005 and menu != 10005:
                menu = 10005
                if (str(settings.getSetting("menu_music")) == "Night"):
                        data = json.load(urlopen(url))
                        night = (data[('Device_Num_%s' % devnight)]['states'][1]['value'])
                        if (str(night) == "0"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=music' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=music' % (ip, dev))
                else:
                        if (str(settings.getSetting("menu_music")) == "Yes"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=music' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=music' % (ip, dev))
                        


        if win == 10500 and menu != 10500:
                menu = 10500
                if (str(settings.getSetting("menu_music")) == "Night"):
                        data = json.load(urlopen(url))
                        night = (data[('Device_Num_%s' % devnight)]['states'][1]['value'])
                        if (str(night) == "0"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=music' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=music' % (ip, dev))
                else:
                        if (str(settings.getSetting("menu_music")) == "Yes"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=music' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=music' % (ip, dev))
                        


        if win == 10501 and menu != 10501:
                menu = 10501
                if (str(settings.getSetting("menu_music")) == "Night"):
                        data = json.load(urlopen(url))
                        night = (data[('Device_Num_%s' % devnight)]['states'][1]['value'])
                        if (str(night) == "0"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=music' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                                print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=music' % (ip, dev))
                else:
                        if (str(settings.getSetting("menu_music")) == "Yes"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=music' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                                print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=music' % (ip, dev))
                        


        if win == 10502 and menu != 10502:
                menu = 10502
                if (str(settings.getSetting("menu_music")) == "Night"):
                        data = json.load(urlopen(url))
                        night = (data[('Device_Num_%s' % devnight)]['states'][1]['value'])
                        if (str(night) == "0"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=music' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=music' % (ip, dev))
                else:
                        if (str(settings.getSetting("menu_music")) == "Yes"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=music' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=music' % (ip, dev))



        if win == 12600 and menu != 12600:
                menu = 12600
                if (str(settings.getSetting("menu_weather")) == "Night"):
                        data = json.load(urlopen(url))
                        night = (data[('Device_Num_%s' % devnight)]['states'][1]['value'])
                        if (str(night) == "0"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=weather' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=weather' % (ip, dev))
                else:
                        if (str(settings.getSetting("menu_weather")) == "Yes"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=weather' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=weather' % (ip, dev))

        if win == winid_1 and menu != winid_1:
                menu = winid_1
                if (str(settings.getSetting("custom_event1")) == "Night"):
                        data = json.load(urlopen(url))
                        night = (data[('Device_Num_%s' % devnight)]['states'][1]['value'])
                        if (str(night) == "0"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=event_1' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=ecent_1' % (ip, dev))
                else:
                        if (str(settings.getSetting("custom_event1")) == "Yes"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=event_1' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=event_1' % (ip, dev))


        if win == winid_2 and menu != winid_2:
                menu = winid_2
                if (str(settings.getSetting("custom_event2")) == "Night"):
                        data = json.load(urlopen(url))
                        night = (data[('Device_Num_%s' % devnight)]['states'][1]['value'])
                        if (str(night) == "0"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=event_2' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=event_2' % (ip, dev))
                else:
                        if (str(settings.getSetting("custom_event2")) == "Yes"):
                                urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=event_2' % (ip, dev))
                                if (str(settings.getSetting("debug_mod")) == "Yes"):
                                        print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=event_2' % (ip, dev))


    
        xbmc.sleep(1000)
else:
        if (str(settings.getSetting("xbmc_ended")) == "Night"):
                data = json.load(urlopen(url))
                night = (data[('Device_Num_%s' % devnight)]['states'][1]['value'])
                if (str(night) == "0"):
                        urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=Xbmc_close' % (ip, dev))
                        urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=----' % (ip, dev))
                        if (str(settings.getSetting("debug_mod")) == "Yes"):
                                print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=Xbmc_close' % (ip, dev))
        else:
                if (str(settings.getSetting("xbmc_ended")) == "Yes"):
                        urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=Xbmc_close' % (ip, dev))
                        urlopen('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=PlayerStatus&Value=----' % (ip, dev))
                        if (str(settings.getSetting("debug_mod")) == "Yes"):
                                print('http://%s:3480/data_request?id=variableset&DeviceNum=%s&serviceId=urn:upnp-org:serviceId:XBMCState1&Variable=IdleTime&Value=Xbmc_close' % (ip, dev))
